; ,4 
;  PPM    
; 1.0b free
;(C)   
;http://radioteh.nm.ru/

;=============================================
        LIST    p=16F84
       __CONFIG 03FF9H
;=============================================

IndF        equ        00h         ;     FSR
Timer0      equ        01h         ; TMR0
OptionR     equ        01h         ; Option (RP0=1)
PC          equ        02h         ;  
Status      equ        03h         ; Status
FSR         equ        04h         ;   
PortA       equ        05h         ; Port A
TrisA       equ        05h         ; Tris A - RP0=1
PortB       equ        06h         ; Port B
TrisB       equ        06h         ; Tris B - RP0=1
EEData      equ        08h         ; EEPROM Data
EECon1      equ        08h         ; EECON1 - RP0=1
EEAdr       equ        09h         ; EEPROM Address
EECon2      equ        09h         ; EECON2 - RP0=1

;=============================================
;                                     
W           equ        0           ; 
F           equ        1           ; 
;
;=============================================
; Flag bits:
CF          equ        0           ; Carry
DC          equ        1           ; DC
ZF          equ        2           ; Zero
RP0         equ        5
;=============================================

RBASE       equ        0Ch             ;  
            cblock     RBASE
            Temp        
            ldCount     
            endc

            ORG        0h

Start
            clrf       PortA       ; RA0..RA3 = 0
            bsf        Status,RP0
            movlw      b'00000000'
            movwf      TrisA       ; RA output
            movlw      b'00000000'
            movwf      TrisB       ; RB output
            bcf        Status,RP0  ;
            movlw      b'00000000'
            movwf      PortB
            movlw      b'00001111'
            movwf      PortA

Sinhro    ; 
            call       ki             ; 
            bsf        PortB,0        ;
            movlw      15h            ;15*514+3
            movwf      ldCount
            call       pause0         ;
            bcf        PortB,0

;********** 1- 
            call       ki
            bsf        Status,RP0
            movlw      b'00000001'
            movwf      TrisA       ; RA0 input
            bcf        Status,RP0  ;
            clrf       PortA       ; RA0..RA4 = 0

detect1     btfsc      PortA,0     ;   1  
            goto       detect1     ;

            bsf        Status,RP0  ;
            movlw      b'00000000' ;
            movwf      TrisA       ; RA output
            bcf        Status,RP0  ; RA0..RA3=1
            movlw      b'00001111'
            movwf      PortA
;********** 2- 
            call       ki
            bsf        Status,RP0
            movlw      b'00000010'
            movwf      TrisA       ; RA1 input
            bcf        Status,RP0  ;
            clrf       PortA       ; RA0..RA4 = 0

detect2     btfsc      PortA,1
            goto       detect2

            bsf        Status,RP0  ;
            movlw      b'00000000' ;
            movwf      TrisA       ; RA output
            bcf        Status,RP0  ; RA0..RA3=1
            movlw      b'00001111'
            movwf      PortA

;********** 3- 
            call       ki
            bsf        Status,RP0
            movlw      b'00000100'
            movwf      TrisA       ; RA0 input
            bcf        Status,RP0  ;
            clrf       PortA       ; RA0..RA4 = 0

detect3     btfsc      PortA,2
            goto       detect3

            bsf        Status,RP0  ;
            movlw      b'00000000' ;
            movwf      TrisA       ; RA output
            bcf        Status,RP0  ; RA0..RA3=1
            movlw      b'00001111'
            movwf      PortA

;********** 4- 
            call       ki
            bsf        Status,RP0
            movlw      b'00001000'
            movwf      TrisA       ; RA0 input
            bcf        Status,RP0  ;
            clrf       PortA       ; RA0..RA4 = 0

detect4     btfsc      PortA,3
            goto       detect4

            bsf        Status,RP0  ;
            movlw      b'00000000' ;
            movwf      TrisA       ; RA output
            bcf        Status,RP0  ; RA0..RA3=1
            movlw      b'00001111'
            movwf      PortA

            goto       Sinhro

;-------------------------------------
;
;-------------------------------------
   
longdel     
            movlw      0ffh
            movwf      ldCount
pause0      
            call       delay
            decfsz     ldCount,f
            goto       pause0
            return      

ki
            bcf        PortB,0
            movlw      30h         ;   
            movwf      Temp
            call       Pause1      ;
            bsf        PortB,0
            movlw      20h         ;  
            movwf      Temp
            call       Pause1      ;

            return

delay                              ;515
            movlw      0ffh
            movwf      Temp
Pause1
            decfsz     Temp,F
            goto       Pause1
            return





            end
